SystemOrganization addCategory: #'AL-Rendering'!

Object subclass: #ALCanvas
	instanceVariableNames: 'stream stack isOpen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Rendering'!

!ALCanvas class methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 08:36'!
on: aStream
	^ self basicNew initializeWithStream: aStream! !

!ALCanvas methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 10:18'!
attribute: name value: value
	stream
		space;
		write: name;
		write: '="'.
	value streamingWriteInto: stream.
	stream put: $"! !

!ALCanvas methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 12:57'!
close: aString
	self flush.
	stream
		put: $<;
		put: $/;
		write: aString;
		put: $>! !

!ALCanvas methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 11:00'!
closeTag
	self close: stack removeLast! !

!ALCanvas methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 13:01'!
flush
	isOpen ifTrue: 
		[stream put: $>.
		isOpen := false]! !

!ALCanvas methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 11:00'!
initializeWithStream: aStream
	stream := aStream.
	stack := OrderedCollection new! !

!ALCanvas methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 12:56'!
open: aString
	stack add: aString.
	stream put: $<.
	stream write: aString.
	isOpen := true.! !

Object subclass: #ALTag
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Rendering'!

!ALTag class methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 08:48'!
withRenderer: aRenderer
	^ self basicNew initializeWithRenderer: aRenderer! !

!ALTag methodsFor: 'initialize-release' stamp: 'cwp 3/13/2011 09:05'!
initializeWithRenderer: aRenderer
	self initialize.
	canvas := aRenderer.
	attributes := IdentityDictionary new! !

!ALTag methodsFor: 'rendering' stamp: 'cwp 3/13/2011 13:00'!
with: aBlock
	canvas flush.
	aBlock value.
	canvas closeTag.! !
